//
// Programmieren ber mySmartUSB light
// Programmer Typ unter vMicro/Uploader ist "Atmel STK500"
// Beim AtTiny mit myAVR ProgTool L-Fuse "Divide clock by 8 internally" abschalten
//
// Blink-Geber fr E-Scooter
// 
// Der Tiny blinkt permanent, ber den Blinkerschalter wird der Ausgang des Blink-Gebers auf die gewnschte
// Seite geschaltet. 
// Der Blink-Geber schaltet Masse, d.h. die Blinklampen mssen fest an 12 V angeschlossen werden.
//	-> Bei LEDs Polaritt beachten.
//
// StVO: Blinkfrequenz 1,5 Hz +- 0,5 Hz (also zwischen 1 und 2 Hz)
// Am angenehmsten wirkt fr mich 1.9 Hz 	// 1,9 Hz -> 526.32, 2 Hz -> 500
//
// V1.0 - 29.03.2022
// Grundgerst 
// -------------------------------------------------------------------------------------------------------------

//#define DEBUG

// defines fuer AtTiny
#if defined ARDUINO_AVR_NANO
#define BLINKEROUT LED_BUILTIN				// Test steuert OnBoard LED an
#else
#define BLINKEROUT PB3						// steuert beim AtTiny den FET an
#endif

float BlinkFrequenz = 1.9;					// Blinkfrequenz in Hz
float BlinkPeriode = 0.0;					// Periodendauer in ms
unsigned long PauseDauer = 0;				// Zeit Variable

// -------------------------------------------------------------------------------------------------------------
void setup()
{
	// IOs - Richtung festlegen
	pinMode(BLINKEROUT, OUTPUT);

	BlinkPeriode = (1.0 / BlinkFrequenz) * 1000;	// 1,9 Hz -> 526.32

#ifdef DEBUG
	// Debugausgaben
	Serial.begin(115000);
	Serial.print("BlinkFrequenz: ");
	Serial.println(BlinkFrequenz);

	Serial.print("BlinkPeriode: ");
	Serial.println(BlinkPeriode);
#endif

}

// -------------------------------------------------------------------------------------------------------------
void loop()
{
	// hier htte man mal ohne schlechtes Gewissen delay() verwenden knnen, aber wenn schon, denn schon ;)
	if (millis() - PauseDauer > BlinkPeriode)					// berlaufsicher, wrap around proof
	{
		digitalWrite(BLINKEROUT, !digitalRead(BLINKEROUT));		// Blinker an/aus
		PauseDauer = millis();
	}
}
